/************************************************************************

(C) Copyright 2004 - Analog Devices, Inc.  All rights reserved.

File Name:		Init_code.c

Author:			Bob Nakib

Date Modified:		10/20/04

Software:		VisualDSP++3.5

Hardware:		ADSP-BF561

Special Connections:  	None

Purpose:	Inflates a compressed user-application image, that has
			been programmed into Flash memory, and runs the inflated
			program from SDRAM.

*************************************************************************/

#include "InitHead.h"

#define INIT_ADDR 0x20000012
#define DXECOUNT_ADDR 0x2000000E

/* ----------------------------------------------
The user must set the UNCOMPR_ADDR field to the 
intended destination address for the uncompress() 
function, i.e. the beginning address of the 
section that was 'reserved' or kept empty in 
the SDRAM memory of the user-application.
----------------------------------------------- */

int UNCOMPR_ADDR = 0x4000;

section("SEG_LDR") void loader_commands()
{
	unsigned char *params_addr, *image_addr;
	int dxecount, source_len;
	unsigned long dest_len;

	union u
	{
		int i;
		short s[2];
	} sample;


	*pFIO2_DIR = 0xFFFF;
	*pFIO2_FLAG_D = 0x0000;

	*pEBIU_AMGCTL |= 0xE; // Enable all banks
		
	sample.s[0] = *((short *)(DXECOUNT_ADDR));
	sample.s[1] = *((short *)(DXECOUNT_ADDR + 2));
	
	dxecount = sample.i;
	
	params_addr = (unsigned char *)(dxecount + INIT_ADDR);
	
	sample.s[0] = *((short *)(params_addr));
	sample.s[1] = *((short *)(params_addr + 2));	
	
	dest_len = (unsigned long)sample.i;
	
	sample.s[0] = *((short *)(params_addr + 4));
	sample.s[1] = *((short *)(params_addr + 6));	
	
	source_len = sample.i;	
	
	image_addr = params_addr + 8;
	
    uncompress((unsigned char *)UNCOMPR_ADDR, &dest_len, image_addr, (unsigned long)source_len);

    
    SECOND_STAGE_LOADER(0, 0);	// load core A DXE	
	SECOND_STAGE_LOADER(0, 1);	// load core B DXE
	SECOND_STAGE_LOADER(1, 0);	// execute core A DXE

}
